import {
    Platform, View,
    Button,
    TextInput,
    StyleSheet,
    Text,
    AsyncStorage, ToastAndroid,
    Alert,
} from 'react-native';
import firebase from 'react-native-firebase';
import ApiServiceList from '../moduels/APiServiceList';
import { showAlert, AppConstants } from '../Utils/constants';

class BumbleConfigService {


    hippoInit = async data => {
        return new Promise(async (resolve, reject) => {
            let propsObj = data;
            console.log(propsObj.sdkStatus);
            let putUserDeatilObj = {
                app_type: propsObj.app_type,
                device_id: propsObj.device_id,
                device_type: Platform.OS == 'android' ? 1 : 2,
                user_unique_key: propsObj.user_unique_key,
                device_token: propsObj.device_token,
                app_secret_key: propsObj.app_secret_key,
                language:propsObj.language
            }

            await AsyncStorage.setItem(AppConstants.deviceToken, putUserDeatilObj.device_token);
            await AsyncStorage.setItem(AppConstants.deviceID, putUserDeatilObj.device_id);
            await AsyncStorage.setItem(AppConstants.appSecretKey, putUserDeatilObj.app_secret_key);
            await AsyncStorage.setItem(AppConstants.language, putUserDeatilObj.language);



            resolve(putUserDetailResponse);
        });
    };

    isBumbleNotification = data => {
        // if (
        // data.hasOwnProperty('push_source') &&
        // data.push_source.toUpperCase() == 'FUGU'
        // )
        return true;
        // else return false;
    };

    async createNotification(notificationMessage) {
        message = notificationMessage._data.message;

        message = JSON.parse(message);

        const channelId = new firebase.notifications.Android.Channel(
            'Bumble',
            'Bumble',
            firebase.notifications.Android.Importance.Max,
        );
        firebase.notifications().android.createChannel(channelId);

        try {
            if (message.channel_id == null) {
                return null;
            }
            let notification_to_be_displayed = new firebase.notifications.Notification({
                data: notificationMessage._data,
                sound: 'default',
                show_in_foreground: true,
                title: message.title,
                body: message.message,
                autoCancel: true,
                url: message.custom_attributes.image.image_url,
                imageUrl: message.custom_attributes.image.image_url
            });
            if (Platform.OS == 'android') {
                notification_to_be_displayed.android
                    .setPriority(firebase.notifications.Android.Priority.High)
                    .android.setAutoCancel(true)
                    .android.setChannelId('Bumble')
                    .android.setVibrate(1000)
                    .android.setBigPicture(message.custom_attributes.image.image_url);

                firebase.notifications().displayNotification(notification_to_be_displayed)
                    .catch(err => console.error(err));


            }
            else if (Platform.OS == 'ios') {


                notification_to_be_displayed.ios.addAttachment("url", message.custom_attributes.image.image_url);

                firebase
                    .notifications()
                    .displayNotification(notification_to_be_displayed)
                    .catch(err => console.error(err));

                console.log("======>>>>>>>>>.", message)
            }
            // }
        } catch (e) {
            console.log(e);
        }
    }

    async login(username, email, number, user_unique_key) {

        console.log('before try')
        try {
            console.log('in try')

            const deviceToken = await AsyncStorage.getItem(AppConstants.deviceToken);

            //app_secret_key,device_token,user_unique_key
            const obj = {
                device_id: "aDnOaWK90p1599473784153kenwfdhwoiujGSDIUUHU82E8HD98",
                device_type: Platform.OS == 'android' ? 1 : 2,
                source: 7,
                lang: "en",
                app_secret_key: "12a06be0ea82ad39149aa943907d3f6b",
                user_unique_key: user_unique_key,
                email: email,
                full_name: username,
                phone_number: number,
                app_version_code: 100,
                device_token: deviceToken,
            };

            if (deviceToken !== null) {

                ApiServiceList.loginAPI(obj)
                    .then(res => {
                        console.log(res);
                        if (res.statusCode == AppConstants.successCode) {

                            AsyncStorage.setItem("app_secret_key", res.data.app_secret_key);
                            AsyncStorage.setItem("en_user_id", res.data.en_user_id);
                            AsyncStorage.setItem("user_id", res.data.user_id + "");
                            console.log("login sucess!!!", res.data.user_id)

                            notifyMessage("login sucess!!!" + res.data.user_id);
                            // this.props.navigation.push('Annoncements');
                            return
                        } else {
                            notifyMessage("login fail!!!");

                        }
                    });
            } else {
                notifyMessage("login fail!!!");
                console.log('error signing up: ', err)

            }
        } catch (err) {
            notifyMessage("login fail!!!");

            console.log('error signing up: ', err)
            console.log('error signing up: ', "err")
        }


    }
}

function notifyMessage(msg) {
    if (Platform.OS === 'android') {
        ToastAndroid.show(msg, ToastAndroid.SHORT)
    } else {
        Alert.alert("alert", msg);
    }
}

const BumbleService = new BumbleConfigService();
export default BumbleService;