/** Firebase Cloud Messaging Methods */
import firebase from 'react-native-firebase';
import { AppConstants } from './constants';
import { AsyncStorage } from 'react-native';

const getToken = async () => {
    try {
        const token = await firebase.messaging().getToken();
        console.log("fcm token", token);
        if (token) {
            AsyncStorage.setItem(AppConstants.deviceToken, token);
            return token;
        }
    } catch (error) {
        console.log(error);
    }
};

const getFCMToken = async () => {
    try {
        const authorized = await firebase.messaging().hasPermission();
        const fcmToken = await getToken();

        if (authorized) return fcmToken;

        await firebase.messaging().requestPermission();
        console.log("fcm token", fcmToken);
        AsyncStorage.setItem(AppConstants.deviceToken, fcmToken);

        return fcmToken;
    } catch (error) {
        console.log(error);
    }
};

export { getFCMToken };