import {Dimensions, PixelRatio} from 'react-native';

const {height, width} = Dimensions.get('window');

export const getAdjustedFontSize = size => {
  return (parseInt(size) * width * (1.8 - 0.002 * width)) / 400;
};

const dimens = {
  ios_statusBar: 20,
  ios_appBar: 44,
  android_appBar: 56,

  //textSize
  text_very_small: getAdjustedFontSize(10),
  text_small: getAdjustedFontSize(12),
  text_medium: getAdjustedFontSize(14),
  text_large: getAdjustedFontSize(16),
  text_xlarge: getAdjustedFontSize(18),
  text_xxlarge: getAdjustedFontSize(20),
  text_xxxlarge: getAdjustedFontSize(22),
  text_xxxxlarge: getAdjustedFontSize(24),

  //padding
  padding_very_small: getAdjustedFontSize(2),
  padding_small: getAdjustedFontSize(4),
  padding_medium: getAdjustedFontSize(8),
  padding_large: getAdjustedFontSize(16),
  padding_xlarge: getAdjustedFontSize(24),
  padding_xxlarge: 36,
  padding_xxxlarge: 48,

  //image size
  image_very_small: 16,
  image_small: 18,
  image_medium: 24,
  image_large: 36,
  image_xlarge: 46,
  image_xxlarge: 72,
  image_xxxlarge: 96,

  //margin
  dp_1: 1,
  dp_2: getAdjustedFontSize(2),
  dp_4: getAdjustedFontSize(4),
  dp_5: getAdjustedFontSize(5),
  dp_6: getAdjustedFontSize(6),
  dp_8: getAdjustedFontSize(8),
  dp_10: getAdjustedFontSize(10),
  dp_12: getAdjustedFontSize(12),
  dp_14: getAdjustedFontSize(14),
  dp_16: getAdjustedFontSize(16),
  dp_18: getAdjustedFontSize(18),
  dp_20: 20,
  dp_22: 22,
  dp_24: getAdjustedFontSize(24),
  dp_28: 28,
  dp_30: 30,
  dp_32: 32,
  dp_36: 36,
  dp_40: 40, 
  dp_42: 42,
  dp_46: 46,
  dp_50: 50,
  dp_52: 52,
  dp_56: 56,
  dp_64: 64,
  dp_80: 80,
  dp_100: 100,
  dp_120: 120,
  dp_300: 300,
  dp_200: getAdjustedFontSize(200),
  windowWidth: width,
  dp_250: getAdjustedFontSize(250),
};

export default dimens;
